import * as React from "react";
import { Command, CommandGroup, GenerateMarkdownPreview, GetIcon, Suggestion } from "../types";
import { Tab } from "../types/Tab";
import { Classes, L18n } from "..";
import { ChildProps } from "../child-props";
import { CommandOrchestrator } from "../commandOrchestrator";
import { Refs } from "../refs";
export interface ReactMdeProps {
    value: string;
    onChange: (value: string) => void;
    selectedTab: "write" | "preview";
    onTabChange: (tab: "write" | "preview") => void;
    generateMarkdownPreview: GenerateMarkdownPreview;
    minEditorHeight: number;
    maxEditorHeight: number;
    minPreviewHeight: number;
    classes?: Classes;
    refs?: Refs;
    commands?: CommandGroup[];
    getIcon?: GetIcon;
    loadingPreview?: React.ReactNode;
    readOnly?: boolean;
    disablePreview?: boolean;
    suggestionTriggerCharacters?: string[];
    loadSuggestions?: (text: string) => Promise<Suggestion[]>;
    childProps?: ChildProps;
    l18n?: L18n;
}
export interface ReactMdeState {
    editorHeight: number;
}
export declare class ReactMde extends React.Component<ReactMdeProps, ReactMdeState> {
    /**
     * "finalRefs" is a clone of "props.refs" except that undefined refs are set to default values
     */
    finalRefs: Refs;
    commandOrchestrator: CommandOrchestrator;
    gripDrag: {
        originalDragY: number;
        originalHeight: number;
    };
    static defaultProps: Partial<ReactMdeProps>;
    constructor(props: ReactMdeProps);
    handleTextChange: (value: string) => void;
    handleGripMouseDown: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    handleGripMouseUp: () => void;
    handleGripMouseMove: (event: MouseEvent) => void;
    handleTabChange: (newTab: Tab) => void;
    componentDidMount(): void;
    handleCommand: (command: Command) => Promise<void>;
    render(): JSX.Element;
}
